/**
 * Architektur & Implementierung von DBMS, Aufgabenblatt 7
 *
 * Bitmap Indexing, Query Processing and WAH Compression
 */
 
#ifndef LOAD_H
#define LOAD_H

/* load data file into row structure 
 *
 * \param filename  name .tbl file to read (input)
 * \param firstrow  pointer to first row in row array (output)
 *                  memory will be allocated in this function
 * \param numrows   number of rows loaded (output)
 * \return zero upon success, error code otherwise
 */
int load_lineitems_rows(char *filename, lineitem_t **firstrow, uint32_t *numrows);


/* load data file into column arrays
 *
 * \param filename  name .tbl file to read (input)
 * \param numrows   number of rows loaded (output)
 * \param columsn   pointer to first row in each column array (output)
 *                  memory will be allocated in this function
 * \return zero upon success, error code otherwise
 */
int 
load_lineitems_columns(char *filename, uint32_t *numrows,
         uint32_t **orderkey, uint32_t **partkey, uint32_t **suppkey, 
         int32_t **linenumber, int64_t **quantity, int64_t **extendedprice,
         int64_t **discount, int64_t **tax, char **returnflag, 
         char **linestatus, uint32_t **shipdate, uint32_t **commitdate, 
         uint32_t **receiptdate, char **shipinstruct, 
         char **shipmode, char **comment);


#endif // LOAD_H
